<?php
/* Who rated this post? Language File
*/
/**
* Polish Language File developed by mybboard.pl for Who rated this post?
* Tłumaczenie: Conors
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1
**/
	if(!defined("IN_MYBB"))
	{
		die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
	}

	$plugins->add_hook("postbit", "who_rated_postbit");

	function who_rated_info()
	{
		return array(
			"name"          => "Who rated this post?",
			"description"   => "Pokazuje kto polubił dany post.",
			"author"        => "Diggenbibo",
			"authorsite"    => "-/-",
			"website"       => "-/-",
			"compatibility" => "*",
			"version"       => "1.1"
		);
	}
	
	/**
	 *  Prints a list of all users who rated the post
	 *  @param $post PostClass
	 */
	function who_rated_postbit(&$post)
	{
		global $db, $templates, $lang;
		
		$lang->load('who_rated');
		$rated_users = get_rated_users($post['pid']);

		// We need an array from the database to work with hence the field username (it could be any other field)
		if(sizeof($rated_users['username']) > 0)
		{
			for($i = 0, $userlist = ""; $i < sizeof($rated_users['username']); $i++)
			{
				$reputation = add_reputation($rated_users['reputation'][$i]);
				$userlist .= "<a href=\"member.php?action=profile&uid={$rated_users['uid'][$i]}\"> {$rated_users['username'][$i]} $reputation</a>";
			
				if(next($rated_users['username']))
				{
					$userlist .= ", ";
				}
			}
			$post['iplogged'] = "{$lang->showtext} $userlist <br />{$post['iplogged']}";
		}
	}

	/**
	 *  Get all informations from the database of the users who rated the post
	 *  @param int PostId
	 *  @return array An array of all users' information who rated the post
	 */
	function get_rated_users($pid) 
	{
		global $db;
		$rated_users = array(
			"username"   => array(),
			"uid"        => array(),
			"reputation" => array()
		);

		$query = $db->query("SELECT DISTINCT " . TABLE_PREFIX . "users.username AS username, " . TABLE_PREFIX . "users.uid AS uid, " . TABLE_PREFIX . "reputation.reputation AS reputation FROM " . TABLE_PREFIX . "users, " . TABLE_PREFIX . "reputation, " . TABLE_PREFIX . "posts WHERE " . TABLE_PREFIX . "reputation.pid = $pid AND " . TABLE_PREFIX . "reputation.adduid = " . TABLE_PREFIX . "users.uid");
		while($result = $db->fetch_array($query))
		{
			$rated_users['username'][]   = htmlspecialchars_uni($result['username']);
			$rated_users['uid'][]        = $result['uid'];
			$rated_users['reputation'][] = $result['reputation'];
		}
		return $rated_users;
	}

	/**
	 *  Adds the reputation
	 *  @param int The reputation value
	 *  @return string The visible reputation
	 */
	function add_reputation($reputation)
	{
		if($reputation < 0)
		{
			return " <strong class=\"reputation_negative\">(-)</strong>";
		}
		else if($reputation > 0)
		{
			return " <strong class=\"reputation_positive\">(+)</strong>";
		}
		else {
				return " <strong class=\"reputation_neutral\">(0)</strong>";
		}
	}
?>
